/**
 * Yum Food Orders
 * **Yum application, order food daily from the best chef in town**  This API is used by the angular.io client, and is not meant to be used otherwise.  Find source code of this API [here](http://gitlab/)  Copyright (C) 2017 JR Technologies.
 *
 * OpenAPI spec version: 1.0.0
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional } from '@angular/core';
import { Http, Headers, URLSearchParams } from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType } from '@angular/http';

import { Observable } from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models from '../model/models';
import { BASE_PATH, COLLECTION_FORMATS } from '../variables';
import { Configuration } from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class HungryApi {
  protected basePath = 'http://localhost:8082/api';
  public defaultHeaders: Headers = new Headers();
  public configuration: Configuration = new Configuration();

  constructor(protected http: Http, @Optional() @Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
    if (basePath) {
      this.basePath = basePath;
    }
    if (configuration) {
      this.configuration = configuration;
    }
  }

    /**
     * Gets the global settings
     * Gets the global settings
     */
    public globalsettingsGet(extraHttpRequestParams?: any): Observable<models.GlobalSettings> {
        return this.globalsettingsGetWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

  /**
   * Gets the menu of a specified day.
   * Returns the menu of a specified day.
   * @param dayDate The requested day
   */
  public menusDayDayDateGet(dayDate: string, extraHttpRequestParams?: any): Observable<models.Menus> {
    return this.menusDayDayDateGetWithHttpInfo(dayDate, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Gets daily menus of the current month.
   * Returns a list of daily menus of the current month.
   */
  public menusMonthlyGet(extraHttpRequestParams?: any): Observable<models.Menus> {
    return this.menusMonthlyGetWithHttpInfo(extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Gets monthly menu of a specified month.
   * Returns a list of monthly menus of a specified month.
   * @param monthOfYear The requested month
   */
  public menusMonthlyMonthOfYearGet(monthOfYear: string, extraHttpRequestParams?: any): Observable<models.Menus> {
    return this.menusMonthlyMonthOfYearGetWithHttpInfo(monthOfYear, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Gets weekly menu
   * Returns a list of daily (5) menus.
   */
  public menusWeeklyGet(extraHttpRequestParams?: any): Observable<models.Menus> {
    return this.menusWeeklyGetWithHttpInfo(extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Gets weekly menu of a specified week.
   * Returns a list of daily (5) menus of a specified week.
   * @param weekOfYear The requested week
   */
  public menusWeeklyWeekOfYearGet(weekOfYear: string, extraHttpRequestParams?: any): Observable<models.Menus> {
    return this.menusWeeklyWeekOfYearGetWithHttpInfo(weekOfYear, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Deletes an order
   * Deletes the daily order matching the id.
   * @param id The Daily order&#39;s id
   */
  public ordersIdDelete(id: number, menuVersion: models.DailyOrder, extraHttpRequestParams?: any): Observable<{}> {
    return this.ordersIdDeleteWithHttpInfo(id, menuVersion, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 200) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Gets an order
   * Gets the daily order matching the id.
   * @param id The Daily order&#39;s id
   */
  public ordersIdGet(id: number, extraHttpRequestParams?: any): Observable<models.DailyOrder> {
    return this.ordersIdGetWithHttpInfo(id, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Updates an order
   * Updates the daily order matching the id.
   * @param id The Daily order&#39;s id
   * @param dailyOrderToUpdate The daily order to update.
   */
  public ordersIdPut(id: number, dailyOrderToUpdate?: models.DailyOrder, extraHttpRequestParams?: any): Observable<{}> {
    return this.ordersIdPutWithHttpInfo(id, dailyOrderToUpdate, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Creates a daily order
   * creates a daily order in the database
   * @param dailyOrder The daily order to create.
   */
  public ordersPost(dailyOrder?: models.DailyOrder, extraHttpRequestParams?: any): Observable<models.DailyOrder> {
    return this.ordersPostWithHttpInfo(dailyOrder, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

    /**
     * Gets the settings of a user.
     * Gets the account settings of the current user.
     */
    public settingsGet(extraHttpRequestParams?: any): Observable<models.UserGet> {
        return this.settingsGetWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Changes the settings of a user.
     * Changes the account settings of the current user.
     * @param userToUpdate The user to update.
     */
    public settingsPut(userToUpdate?: models.UserPut, extraHttpRequestParams?: any): Observable<{}> {
        return this.settingsPutWithHttpInfo(userToUpdate, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }


  /**
   * Gets the menu of a specified day.
   * Returns the menu of a specified day.
   * @param dayDate The requested day
   */
  public menusDayDayDateGetWithHttpInfo(dayDate: string, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/menus/day/${dayDate}`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // verify required parameter 'dayDate' is not null or undefined
    if (dayDate === null || dayDate === undefined) {
      throw new Error('Required parameter dayDate was null or undefined when calling menusDayDayDateGet.');
    }
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Get,
      headers: headers,
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Gets daily menus of the current month.
   * Returns a list of daily menus of the current month.
   */
  public menusMonthlyGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/menus/monthly`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Get,
      headers: headers,
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Gets monthly menu of a specified month.
   * Returns a list of monthly menus of a specified month.
   * @param monthOfYear The requested month
   */
  public menusMonthlyMonthOfYearGetWithHttpInfo(monthOfYear: string, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/menus/monthly/${monthOfYear}`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // verify required parameter 'monthOfYear' is not null or undefined
    if (monthOfYear === null || monthOfYear === undefined) {
      throw new Error('Required parameter monthOfYear was null or undefined when calling menusMonthlyMonthOfYearGet.');
    }
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Get,
      headers: headers,
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Gets weekly menu
   * Returns a list of daily (5) menus.
   */
  public menusWeeklyGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/menus/weekly`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Get,
      headers: headers,
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

      /**
     * Gets the global settings
     * Gets the global settings
     */
    public globalsettingsGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/globalsettings`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

  /**
   * Gets weekly menu of a specified week.
   * Returns a list of daily (5) menus of a specified week.
   * @param weekOfYear The requested week
   */
  public menusWeeklyWeekOfYearGetWithHttpInfo(weekOfYear: string, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/menus/weekly/${weekOfYear}`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // verify required parameter 'weekOfYear' is not null or undefined
    if (weekOfYear === null || weekOfYear === undefined) {
      throw new Error('Required parameter weekOfYear was null or undefined when calling menusWeeklyWeekOfYearGet.');
    }
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Get,
      headers: headers,
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Deletes an order
   * Deletes the daily order matching the id.
   * @param id The Daily order&#39;s id
   */
  public ordersIdDeleteWithHttpInfo(id: number, menuVersion: models.DailyOrder, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/orders/${id}`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // verify required parameter 'id' is not null or undefined
    if (id === null || id === undefined) {
      throw new Error('Required parameter id was null or undefined when calling ordersIdDelete.');
    }
    // verify required parameter 'menuVersion' is not null or undefined
    if (menuVersion === null || menuVersion === undefined) {
      throw new Error('Required parameter menuVersion was null or undefined when calling ordersIdDelete.');
    }
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    headers.set('Content-Type', 'application/json');

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Delete,
      headers: headers,
      body: menuVersion == null ? '' : JSON.stringify(menuVersion), // https://github.com/angular/angular/issues/10612
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Gets an order
   * Gets the daily order matching the id.
   * @param id The Daily order&#39;s id
   */
  public ordersIdGetWithHttpInfo(id: number, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/orders/${id}`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // verify required parameter 'id' is not null or undefined
    if (id === null || id === undefined) {
      throw new Error('Required parameter id was null or undefined when calling ordersIdGet.');
    }
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Get,
      headers: headers,
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Updates an order
   * Updates the daily order matching the id.
   * @param id The Daily order&#39;s id
   * @param dailyOrderToUpdate The daily order to update.
   */
  public ordersIdPutWithHttpInfo(id: number, dailyOrderToUpdate?: models.DailyOrder, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/orders/${id}`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // verify required parameter 'id' is not null or undefined
    if (id === null || id === undefined) {
      throw new Error('Required parameter id was null or undefined when calling ordersIdPut.');
    }
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    headers.set('Content-Type', 'application/json');

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Put,
      headers: headers,
      body: dailyOrderToUpdate == null ? '' : JSON.stringify(dailyOrderToUpdate), // https://github.com/angular/angular/issues/10612
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Creates a daily order
   * creates a daily order in the database
   * @param dailyOrder The daily order to create.
   */
  public ordersPostWithHttpInfo(dailyOrder?: models.DailyOrder, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/orders`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    headers.set('Content-Type', 'application/json');

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Post,
      headers: headers,
      body: dailyOrder == null ? '' : JSON.stringify(dailyOrder), // https://github.com/angular/angular/issues/10612
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

    /**
     * Gets the settings of a user.
     * Gets the account settings of the current user.
     */
    public settingsGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/settings`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Changes the settings of a user.
     * Changes the account settings of the current user.
     * @param userToUpdate The user to update.
     */
    public settingsPutWithHttpInfo(userToUpdate?: models.UserPut, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/settings`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: userToUpdate == null ? '' : JSON.stringify(userToUpdate), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

 /**
     * Delete user picture.
     *
     */
    public settingsPictureDelete(extraHttpRequestParams?: any): Observable<{}> {
        return this.settingsPictureDeleteWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Upload user picture.
     *
     * @param file The file to upload.
     */
    // public settingsPicturePost(file?: any, extraHttpRequestParams?: any): Observable<{}> {
    //     return this.settingsPicturePostWithHttpInfo(file, extraHttpRequestParams)
    //         .map((response: Response) => {
    //             if (response.status === 204) {
    //                 return undefined;
    //             } else {
    //                 return response.json();
    //             }
    //         });
    // }

    /**
     * Gets user&#39;s picture
     *
     * @param token The token of the current session.
     */
    public settingsPictureTokenGet(token: string, extraHttpRequestParams?: any): Observable<any> {
        return this.settingsPictureTokenGetWithHttpInfo(token, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

/**
     * Delete user picture.
     *
     */
    public settingsPictureDeleteWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/settings/picture`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Upload user picture.
     *
     * @param file The file to upload.
     */
    // public settingsPicturePostWithHttpInfo(file?: any, extraHttpRequestParams?: any): Observable<Response> {
    //     const path = this.basePath + `/settings/picture`;

    //     let queryParameters = new URLSearchParams();
    //     let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    //     let formParams = new URLSearchParams();

    //     // to determine the Content-Type header
    //     let consumes: string[] = [
    //         'multipart/form-data'
    //     ];

    //     // to determine the Accept header
    //     let produces: string[] = [
    //         'application/json'
    //     ];

    //     // authentication (Bearer) required
    //     if (this.configuration.apiKey) {
    //         headers.set('Authorization', this.configuration.apiKey);
    //     }

    //     headers.set('Content-Type', 'application/x-www-form-urlencoded');

    //     if (file !== undefined) {
    //         formParams.set('file', <any>file);
    //     }

    //     let requestOptions: RequestOptionsArgs = new RequestOptions({
    //         method: RequestMethod.Post,
    //         headers: headers,
    //         body: formParams.toString(),
    //         search: queryParameters
    //     });

    //     // https://github.com/swagger-api/swagger-codegen/issues/4037
    //     if (extraHttpRequestParams) {
    //         requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    //     }

    //     return this.http.request(path, requestOptions);
    // }

    /**
     * Gets user&#39;s picture
     *
     * @param token The token of the current session.
     */
    public settingsPictureTokenGetWithHttpInfo(token: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/settings/picture/token`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'token' is not null or undefined
        if (token === null || token === undefined) {
            throw new Error('Required parameter token was null or undefined when calling settingsPictureTokenGet.');
        }
        if (token !== undefined) {
          queryParameters.set('token', <any>token);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'image/jpeg'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

}
